<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmTimer4: ReadMe</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">kmTimer4
   </div>
   <div id="projectbrief">kmTimer4 library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('md__x_1__r_e_a_d_m_e.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">ReadMe </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1>kmTimer4 library for AVR MCUs</h1>
<p>The kmTimer4 library provides functions to initialize and control Timer 0 on AVR MCUs. It allows generating square waves with specified duty cycle and frequency, registering callbacks for overflow and comparator interrupts, enabling/disabling interrupts, configuring comparator outputs, controlling timer flow, and setting PWM duty cycles.</p>
<h2>Table of Contents</h2>
<ul>
<li><a href="#version-history">Version History</a></li>
<li><a href="#overview">Overview</a></li>
<li><a href="#dependencies">Dependencies</a></li>
<li><a href="#usage">Usage</a></li>
<li><a href="#example-code">Example Code</a></li>
<li><a href="#author-and-license">Author and License</a></li>
</ul>
<h2>Version History</h2>
<p>v1.0.0 Initial (2024-05-25)</p>
<h2>Overview</h2>
<p>This library is designed for older models of AVR MCUs like ATmega8, ATmega32, etc. It initializes Timer 0 to generate square waves using Phase Accurate mode, allowing precise control over duty cycle and frequency. Callback functions can be registered for overflow and comparator interrupts, enabling users to execute custom routines at specific moments within Timer 0 periods.</p>
<h2>Dependencies</h2>
<ul>
<li><a href="https://gitlab.com/c-mos/kmAvrLibs">kmFrameworkAVR</a><ul>
<li><a href="https://gitlab.com/c-mos/kmAvrLibs/kmCommon">kmCommon</a></li>
<li><a href="https://gitlab.com/c-mos/kmAvrLibs/kmCpu">kmCpu</a></li>
<li><a href="https://gitlab.com/c-mos/kmAvrLibs/kmTimersCommon">kmTimersCommon</a></li>
</ul>
</li>
</ul>
<h2>Usage</h2>
<p>Getting this library and adding it to own project:</p><ul>
<li>To add this module to own project as submodule - enter the main directory of the source code and use git command</li>
</ul>
<div class="fragment"><div class="line">git submodule add git@gitlab.com:c-mos/kmAvrLibs/kmTimer4.git kmTimer4</div></div><!-- fragment --><ul>
<li>After cloning own application from git repository use following additional git command to get correct revision of submodule: <div class="fragment"><div class="line">git submodule update --init</div></div><!-- fragment --></li>
<li>Include the library in your AVR project.</li>
<li>Initialize Timer 4 using <code>kmTimer4InitOnPrescalerBottomToTopPcPwmOCA</code>.</li>
<li>Register callback functions for overflow and comparator interrupts using <code>kmTimer4RegisterCallbackOVF</code> and <code>kmTimer4RegisterCallbackCompA</code>, respectively.</li>
<li>Enable interrupts using <code>kmTimer4EnableInterruptOVF</code> and <code>kmTimer4EnableInterruptCompA</code>.</li>
<li>Configure comparator outputs using <code>kmTimer4ConfigureOCA</code>.</li>
<li>Control timer flow using <code>kmTimer4Start</code>, <code>kmTimer4Stop</code>, and <code>kmTimer4Restart</code>.</li>
<li>Set PWM duty cycles using <code>kmTimer4SetPwmDutyBottomToTop</code> and <code>kmTimer4SetPwmDutyAccurateTimeModes</code>.</li>
<li>Include the library in your AVR project.</li>
<li>Initialize Timer 0 using <code>kmTimer4InitOnPrescalerBottomToTopPcPwmOCA</code>.</li>
<li>Register callback functions for overflow and comparator interrupts using <code>kmTimer4RegisterCallbackOVF</code> and <code>kmTimerrRegisterCallbackCompA</code>, respectively.</li>
<li>Enable interrupts using <code>kmTimer4EnableInterruptOVF</code> and <code>kmTimer4EnableInterruptCompA</code>.</li>
<li>Configure comparator outputs using <code>kmTimer4ConfigureOCA</code>.</li>
<li>Control timer flow using <code>kmTimer4Start</code>, <code>kmTimer4Stop</code>, and <code>kmTimer4Restart</code>.</li>
<li>Set PWM duty cycles using <code>kmTimer4SetPwmDutyBottomToTop</code> and <code>kmTimer4SetPwmDutyAccurateTimeModes</code>.</li>
</ul>
<p>## Example Code </p><div class="fragment"><div class="line"><span class="preprocessor">#define KM_TIMER4_TEST_USER_DATA_A 1UL</span></div><div class="line"><span class="preprocessor">#define KM_TIMER4_TEST_USER_DATA_B 65535UL</span></div><div class="line"><span class="preprocessor">#define KM_TIMER4_TEST_USER_DATA_C 255UL</span></div><div class="line"><span class="preprocessor">#define KM_TIMER4_TEST_DUTY_0_PERC KM_TIMER0_BOTTOM</span></div><div class="line"><span class="preprocessor">#define KM_TIMER4_TEST_DUTY_25_PERC KM_TIMER0_MID - (KM_TIMER0_MID &gt;&gt; 1)</span></div><div class="line"><span class="preprocessor">#define KM_TIMER4_TEST_DUTY_50_PERC KM_TIMER0_MID</span></div><div class="line"><span class="preprocessor">#define KM_TIMER4_TEST_DUTY_75_PERC KM_TIMER0_MID + (KM_TIMER0_MID &gt;&gt; 1)</span></div><div class="line"><span class="preprocessor">#define KM_TIMER4_TEST_DUTY_100_PERC KM_TIMER0_TOP</span></div><div class="line"></div><div class="line"><span class="preprocessor">#include &quot;kmCpu/kmCpu.h&quot;</span></div><div class="line"><span class="preprocessor">#include &quot;kmDebug/kmDebug.h&quot;</span></div><div class="line"><span class="preprocessor">#include &quot;kmTimersCommon/kmTimerDefs.h&quot;</span></div><div class="line"><span class="preprocessor">#include &quot;kmTimer4/kmTimer4.h&quot;</span></div><div class="line"></div><div class="line"><span class="keywordtype">void</span> callbackOVF(<span class="keywordtype">void</span> *userData) {</div><div class="line">    dbToggle(DB_PIN_0);</div><div class="line">    dbOn(DB_PIN_1);</div><div class="line">    dbOn(DB_PIN_2);</div><div class="line">}</div><div class="line"></div><div class="line"><span class="keywordtype">void</span> callbackCompAOff(<span class="keywordtype">void</span> *userData) {</div><div class="line">    dbOff(DB_PIN_1);</div><div class="line">}</div><div class="line"></div><div class="line"><span class="keywordtype">void</span> callbackCompBOff(<span class="keywordtype">void</span> *userData) {</div><div class="line">    dbOff(DB_PIN_2);</div><div class="line">}</div><div class="line"></div><div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">void</span>) {</div><div class="line">    appInitDebug();</div><div class="line">    kmCpuInterruptsEnable();</div><div class="line"></div><div class="line">    kmTimer4InitOnPrescalerBottomToTopOvfCompABInterruptCallback(KM_TCC0_PRSC_8);</div><div class="line"></div><div class="line">    <a class="code" href="km_timer4_8h.html#a94bafd8412a4ef21ea1342ce676ca384">kmTimer4RegisterCallbackOVF</a>(KM_TIMER0_USER_DATA(KM_TIMER0_TEST_USER_DATA_B), callbackOVF);</div><div class="line">    <a class="code" href="km_timer4_8h.html#a98a5f1076cbd17f38999aef18badfef3">kmTimer4EnableInterruptOVF</a>();</div><div class="line"></div><div class="line">    <a class="code" href="km_timer4_8h.html#ab8697b2db0329462446e946906c21eb3">kmTimer4RegisterCallbackCompA</a>(KM_TIMER0_USER_DATA(KM_TIMER0_TEST_USER_DATA_A), callbackCompAOff);</div><div class="line">    <a class="code" href="km_timer4_8h.html#a8e8fc2551c6a96f660fb5ccd94e3a9cb">kmTimer4SetValueCompA</a>(KM_TIMER0_TEST_DUTY_25_PERC);</div><div class="line">    <a class="code" href="km_timer4_8h.html#a8a4333b2e38d16d9b0fe99c30e0d1196">kmTimer4EnableInterruptCompA</a>();</div><div class="line"></div><div class="line">    <a class="code" href="km_timer4_8h.html#ab8498241febbd89502a935247f67150d">kmTimer4RegisterCallbackCompB</a>(KM_TIMER0_USER_DATA(KM_TIMER0_TEST_USER_DATA_C), callbackCompBOff);</div><div class="line">    <a class="code" href="km_timer4_8h.html#a657ea8bfca17f3fd9d6bd461c7bd6709">kmTimer4SetValueCompB</a>(KM_TIMER0_TEST_DUTY_75_PERC);</div><div class="line">    <a class="code" href="km_timer4_8h.html#ab301d7a6d0dbafc9bc419531a33882e4">kmTimer4EnableInterruptCompB</a>();</div><div class="line"></div><div class="line">    <a class="code" href="km_timer4_8h.html#a1c919fa7afe6f0066897286f5d335fe1">kmTimer4Start</a>();</div><div class="line"></div><div class="line">    <span class="keywordflow">while</span>(<span class="keyword">true</span>) {</div><div class="line">    }</div><div class="line">}</div></div><!-- fragment --><p>See Also: <a href="https://gitlab.com/c-mos/kmAvrTests/kmTimer4Test">kmTimer4 Example Test Application</a></p>
<h2>Author and License</h2>
<p><b>Author</b>: Krzysztof Moskwa</p>
<p><b>e-mail</b>: chris[dot]moskva[at]gmail[dot]com</p>
<p><b>License</b>: GPL-3.0-or-later</p>
<p>Software License: GNU General Public License (GPL) version 3.0 or later. See <a href="https://www.gnu.org/licenses/gpl-3.0.txt">LICENSE.txt</a></p>
<img src="https://www.gnu.org/graphics/gplv3-or-later-sm.png" alt="GPL3 Logo" class="inline"/>
 </div></div><!-- PageDoc -->
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.15 </li>
  </ul>
</div>
</body>
</html>
